---
layout: cp
title: Improving Developer Guides to include Simplewallet examples and Bitmonerod methods and examples
author: bigreddmachine
amount: 90
date: March 8, 2016
---
### What do I want to do and why?
For some time, the Developer Guides under Knowledge Base have been quite short on material. There is some documentation of simplewallet JSON RPC methods, but no complete examples. In addition, there is no information on bitmonerod methods.

Recently, I have been working on building out a Python package for Monero. My initial focus has been to build a comprehensive package for talking with the daemon and simplewallet via RPC methods. As a result, I have had to pull information from many different sources so that I can flesh out my package (primarily working from other packages, example sites, BitcoinTalk, reddit, and the main bitmonero GitHub source code).

I would like to turn my efforts around and compile all of this information into the getmonero.org Knowledge Base so that future developers will not have to go through the same struggle. This is separate from the work I am already doing on my Python package.

### Who Am I?
I am a PhD student and graduate researcher in engineering, and have been in the cryptocurrency space for a little over two years. I have contributed in small amounts to various cryptocurrency projects. Most relevantly, I am the creator of the [Monero Monitor Chrome Extension](https://chrome.google.com/webstore/detail/monero-monitor/ojekadcfnkkihlleaafggfgbggdckpgo) and am currently working on [Pymonero](https://github.com/Monero-Monitor/pymonero).

### Proposed Milestones:
1. Add examples (with return examples) to the [Simplewallet RPC information already available](https://getmonero.org/knowledge-base/developer-guides/wallet-rpc).
2. Create a similar page for the Bitmonero daemon RPC interface, including both the JSON RPC methods and other methods such as ```/gettransactions``` and ```/is_key_image_spent```.


### Funding:
In total, I anticipate this task will take me 6 hours, including creating examples of both valid and invalid method calls. This is on top of the time that I am spending on my own to continue to develop Pymonero to be a comprehensive Python tool. I anticipate that I will be able to complete both milestones over a two week period during evenings after my actual job.

I am asking to raise 90 XMR, or 15 XMR/hr. Please let me know if this seems reasonable.

**-Mike, a.k.a. BRM**